﻿(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var resourceHeadTemplate = function () {
        return ("{{for resourceName}}{{for ~cols=colspan}}<td class='e-resourcecells' colspan='{{:~cols}}'> {{for ~resource=resourceNam}}<div class='e-resourceheadertext' align='center' title='{{if userResTemplId == true}}{{:resourceNam}}{{else}}{{:~resource}}{{/if}}'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resource}}{{/if}}</div>{{/for}}  </td>{{/for}}{{/for}}");
    };

    ej.scheduleFeatures.resources = {
        _getMultipleResourceCellsCount: function (count) {
            if (this._grouping.length === 1) {
                var index = this._findResourceIndex(this._tempResource, "name", this._grouping[0]);
                var resCount = this._resourceInfo[index].dataSource.length;
                if (this._resWorkWeek) {
                    var count = 0; var res = this._resourceInfo[index].dataSource;
                    for (var a = 0; a < res.length; a++) {
                        if (!ej.isNullOrUndefined(res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count = count + res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count = count + this.model.workWeek.length;
                        }
                    }
                }
            }
            else {
                var newResCollection = this._getResourceCollection(), resources = [];
                var groupData, prevGroupDataId, query, resApp;
                for (var j = 0; j < newResCollection.length; j++) {
                    resources = [];
                    if (j == 0) {
                        for (var i = 0; i < newResCollection[j].dataSource.length; i++) {
                            resources.push({ resourceNam: newResCollection[j].dataSource[i][newResCollection[j].text] });
                        }
                    }
                    else {
                        if (j > 1) {
                            newResCollection[j - 1].dataSource = [];
                            newResCollection[j - 1].dataSource = this.res;
                        }
                        this.res = [];
                        groupData = ej.group(newResCollection[j].dataSource, newResCollection[j].groupId);
                        prevGroupDataId = ej.group(newResCollection[j - 1].dataSource, newResCollection[j - 1].id);
                        this._resourceManager1 = groupData instanceof ej.DataManager ? groupData : ej.DataManager(groupData);
                        for (var l = 0; l < prevGroupDataId.length; l++) {
                            for (var k = 0; k < prevGroupDataId[l].items.length; k++) {
                                query = new ej.Query().where("key", ej.FilterOperators.equal, prevGroupDataId[l].items[k][newResCollection[j - 1].id]);
                                resApp = this._resourceManager1.executeLocal(query);
                                if (resApp.length > 0) {
                                    for (var a = 0; a < resApp[0].items.length; a++) {
                                        resources.push({ resourceNam: resApp[0].items[a][newResCollection[j].text] });
                                        this.res.push(resApp[0].items[a]);
                                    }
                                }
                            }
                        }
                    }
                }
                resCount = resources.length;
                this.res1 = resources.length;
            }
            count = (this._resWorkWeek) ? count : count * resCount;
            return { resCount: resCount, count: count };
        },

        _initResourceData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this;
            var queryPromise = fields.dataSource.executeQuery(query);
            queryPromise.done(function (e) {
                fields.dataSource = e.result;
                proxy._resourceInfo.push(fields);
                if (i == proxy.model.resources.length - 1) {
                    proxy._renderInitSchedule();
                    proxy._bindAppointmentsData("Load");
                }
            });
        },

        _showMultipleResourceDetails: function (temp) {
            var prevdata, query, resApp1;
            if (this._tempResource.length > 0) {
                var newResCollection = this._resCollection;
                for (var i = 0; i < newResCollection.length; i++) {
                    this._appointmentAddWindow.find('.owner_' + i).ejAutocomplete("clearText");
                }
                for (var j = 0; j < this.render_Resources.length - 1; j++) {
                    prevdata = this.render_Resources[j + 1] instanceof ej.DataManager ? this.render_Resources[j + 1] : ej.DataManager(this.render_Resources[j + 1]);
                    query = new ej.Query().where(newResCollection[j + 1].groupId, ej.FilterOperators.equal, temp[this._appointmentSettings.resourceFields.toString().split(',')[j].trim()]);
                    resApp1 = prevdata.executeLocal(query);
                    this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("clearText");
                    this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("option", "dataSource", resApp1);
                }
                for (var i = 0; i < newResCollection.length; i++) {
                    this._appointmentAddWindow.find('.owner_' + i).data("ejAutocomplete").selectValueByKey(temp[this._appointmentSettings.resourceFields.toString().split(',')[i].trim()]);
                }
            }
        },

        _renderAppWindowResources: function (control) {
            var newResCollection = this.render_Resources;
            var Text = (this.model.enableRTL) ? 'margin-right:30px;margin-top:-18px' : '';
            var Color = (this.model.enableRTL) ? 'float:none' : 'float:left';
            for (var i = 0; i < newResCollection.length; i++) {
                control.find('.owner_' + i).ejAutocomplete({
                    enableRTL: this.model.enableRTL,
                    showPopupButton: true,
                    width: "100%",
                    cssClass: this.model.cssClass,
                    multiSelectMode: (!this._tempResource[i].allowMultiple) ? "none" : "visualmode",
                    emptyResultText: this._getLocalizedLabels("EmptyResultText"),
                    dataSource: newResCollection[i],
                    fields: {
                        text: this._resCollection[i]["text"],
                        key: this._resCollection[i]["id"]
                    },
                    change: this._onResourceChange,
                    template: "<div class='e-resourcediv' style='height:15px; margin-right:5px; margin-top:3px; float:left;width:15px;" + Color + "; background-color: ${" + this._resCollection[i].color + "}'></div><div style= " + Text + ">${" + this._resCollection[i]["text"] + "}</div>"
                });
            }
        },

        _onResourceChange: function (e) {
            if (!ej.isNullOrUndefined(e.value) && e.value != "") {
                var scheduleDiv = $("#" + this._id.toString().split("_")[0]), proxy = scheduleDiv.ejSchedule("instance");
                var controlId = parseInt(this._id.toString().split("_")[2]);
                var controlMode = proxy._appointmentAddWindow.find('.owner_' + controlId).ejAutocomplete("option", "multiSelectMode");
                var selectedItems = this.getSelectedItems();
                var resourceCollection = proxy._resCollection;
                if (controlId < proxy.render_Resources.length - 1 && selectedItems.length > 0) {
                    var j = controlId + 1;
                    var data = proxy.render_Resources[j - 1] instanceof ej.DataManager ? proxy.render_Resources[j - 1] : ej.DataManager(proxy.render_Resources[j - 1]);
                    var prevdata = proxy.render_Resources[j] instanceof ej.DataManager ? proxy.render_Resources[j] : ej.DataManager(proxy.render_Resources[j]);
                    var query, resApp1, fieldCollection = [];
                    if (controlMode == "none") {
                        if (!ej.isNullOrUndefined(e.value)) {
                            var textCheck = new ej.Query().where(resourceCollection[j - 1].text, ej.FilterOperators.equal, e.value);
                            var result = data.executeLocal(textCheck);
                        }
                        var currentVal = ((!e.value) || ej.isNullOrUndefined(e.value) || result.length <= 0) ? selectedItems[0][resourceCollection[j - 1].id] : result[0][resourceCollection[j - 1].id];
                        if (!ej.isNullOrUndefined(currentVal)) {
                            for (a = j; a < resourceCollection.length; a++) {
                                resApp1 = new ej.DataManager(resourceCollection[j].dataSource).executeLocal(new ej.Query().where(resourceCollection[j].groupId, ej.FilterOperators.equal, currentVal));
                                if (resApp1.length != 0)
                                    currentVal = resApp1[0][resourceCollection[j - 1].id];
                                fieldCollection = [];
                                for (var k = 0; k < resApp1.length; k++) {
                                    fieldCollection.push(resApp1[k]);
                                }
                                if (resApp1.length != 0) {
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                                    proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
                                    selectedItems = resApp1[0][resourceCollection[j].id];
                                }
                                else {
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                                }
                                j++;
                            }
                        }
                    }
                    else {
                        var predicate;
                        predicate = ej.Predicate(resourceCollection[j - 1].id, ej.FilterOperators.equal, selectedItems[0][resourceCollection[j - 1].id]);
                        selectedItems = e.value.split(",");
                        for (var i = 1; i < selectedItems.length; i++) {
                            predicate = predicate["or"](resourceCollection[j - 1].text, ej.FilterOperators.equal, selectedItems[i]);
                        }
                        query = new ej.Query().where(predicate);
                        resApp = data.executeLocal(query);
                        if (resApp.length > 0) {
                            var prevPredicate;
                            prevPredicate = ej.Predicate(resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[0][resourceCollection[j - 1].id]);
                            for (var i = 1; i < resApp.length; i++) {
                                prevPredicate = prevPredicate["or"](resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[i][resourceCollection[j - 1].id]);
                            }
                            query = new ej.Query().where(prevPredicate);
                            resApp1 = prevdata.executeLocal(query);
                            fieldCollection = [];
                            for (var k = 0; k < resApp1.length; k++) {
                                fieldCollection.push(resApp1[k]);
                            }
                            proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                            proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                            proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
                            selectedItems.push(resApp1[0][resourceCollection[j].id]);
                        }
                    }
                }
            }
        },

        _getResourceCollection: function () {
            var resIndexCollection = [], index;
            if ((this._tempResource.length != 0)) {
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i]);
                        resIndexCollection.push({ index: index, name: this._tempResource[i].name });
                    }
                    resIndexCollection = resIndexCollection.sort(function (a, b) {
                        var x = a.index; var y = b.index;
                        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
                    });
                }
                else {
                    for (var i = 0; i < this._tempResource.length; i++) {
                        resIndexCollection.push({ index: i });
                    }
                }
                var newResCollection = [];
                for (var k = 0; k < resIndexCollection.length; k++) {
                    newResCollection.push(this._resourceInfo[resIndexCollection[k].index]);
                }
                this._resCollection = newResCollection;
                return newResCollection;
            }
        },

        _resourceSort: function () {
            var nextRes, count, resAvail, index, rIndex, cRes, tempResource = [], rCollection = [], tempRes1 = [];
            if (this._tempResource.length > 1) {
                for (i = 0; i < this._tempResource.length; i++) {
                    for (j = 0; j < this._tempResource[i].resourceSettings.dataSource.length; j++) {
                        tempResource.push(this._tempResource[i].resourceSettings.dataSource[j]);
                    }
                }
                count = 1;
                for (a = 0; a < this._tempResource.length; a++) {
                    for (b = 0, cRes = this._tempResource[a].resourceSettings.dataSource; b < cRes.length; b++) {
                        resAvail = rCollection.indexOf(cRes[b]);
                        (resAvail == -1) ? rCollection.push(cRes[b]) : "";
                        nextRes = new ej.DataManager(tempResource).executeLocal(new ej.Query().where(this._tempResource[count].resourceSettings.groupId, ej.FilterOperators.equal, cRes[b][this._tempResource[a].resourceSettings.id]));
                        nextRes = nextRes.filter(function (a) { return cRes.indexOf(a) === -1; });
                        index = rCollection.indexOf(cRes[b]);
                        if (nextRes.length != 0) {
                            for (c = 0; c < nextRes.length; c++) {
                                rIndex = index + c + 1;
                                resAvail = rCollection.indexOf(nextRes[c]);
                                (resAvail == -1) ? rCollection.splice(rIndex, 0, nextRes[c]) : "";
                            }
                        }
                    }
                    count++;
                    count = (count == this._tempResource.length) ? count - 1 : count;
                }
                for (x = 0; x < rCollection.length; x++) {
                    index = this.res1.indexOf(rCollection[x]);
                    if (index != -1) tempRes1.push(rCollection[x]);
                }
                this.res1 = tempRes1;
            }
            else
                rCollection = this.res1;
            return rCollection;
        },

        _renderMultipleResourceHeaderTemplate: function (tbody, cols) {
            this.res1 = []; this.render_Resources = []; this.level_Resources = [];
            var view = this.currentView(); var newResCollection = this._getResourceCollection();
            var viewColCount = view == "day" ? 1 : view == "week" || view == "month" ? 7 : this.model.workWeek.length;
            viewColCount = (view == "customview" && this._dateRender.length >= 7) ? 7 : (view == "customview" && this._dateRender.length < 7) ? this._dateRender.length : viewColCount;
            if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
                var resources = [];
                if (this._grouping.length === 1) {
                    var index;
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i]);
                    }
                    for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
                        if (this._resWorkWeek)
                            var colCount = !ej.isNullOrUndefined(this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : viewColCount;
                        (this.currentView() != "agenda") && resources.push({ resourceNam: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], colspan: (this._resWorkWeek) ? colCount : viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(this._resourceInfo[index].dataSource[i], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                        this.res1.push(this._resourceInfo[index].dataSource[i]);
                        this.level_Resources.push(this.res1[i]);
                    }
                    this._valueCollection = this.res1;
                    this.render_Resources.push(this.res1);
                    if (this.model.orientation == "vertical" && this.currentView() != "agenda" && tbody !== null && cols != null) {
                        var leftCellwidth = view == "month" ? 50 : 56;
                        var resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
                        tbody.append(ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml));
                    }
                }
                else {
                    var groupDatasource = [], firstValue = [], collection = [], resAppValueCount = 0, valueCount = [];
                    var res = []; var level = []; var variable = []; this.resourceValue = 0; var resourceLength = 0;
                    groupDatasource = $.merge(groupDatasource, newResCollection);
                    if (this._tempResource.length) {
                        var k = 0;
                        for (j = 0; j < newResCollection[newResCollection.length - 2].dataSource.length; j++) {
                            var query = new ej.Query().where(newResCollection[newResCollection.length - 1].groupId, ej.FilterOperators.equal, newResCollection[newResCollection.length - 2].dataSource[j][newResCollection[newResCollection.length - 2].id]);
                            var resApp = new ej.DataManager(newResCollection[newResCollection.length - 1].dataSource).executeLocal(query);
                            var m = 0;
                            while (m < resApp.length) {
                                firstValue.push({ resourceNam: resApp[m][newResCollection[newResCollection.length - 1].text], colspan: 1 * viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(resApp[m], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                                collection[k] = resApp[m];
                                this.res1.push(resApp[m]);
                                k++;
                                m++;
                            }
                        }
                        this._valueCollection = collection;
                        newResCollection[newResCollection.length - 1].dataSource = collection;
                        var resClone = $.extend(true, [], newResCollection);
                    }
                    for (var i = this._tempResource.length - 1; i >= 0 ; i--) {
                        level.push(i);
                        for (var j = 0; j < newResCollection[i].dataSource.length; j++) {
                            var valuefirst = i != 0 ? this._findResourceIndex(newResCollection[i - 1].dataSource, newResCollection[i - 1].id, newResCollection[i].dataSource[j][newResCollection[i].groupId]) : 0;
                            var valuelast = i != this._tempResource.length - 1 ? this._findResourceIndex(newResCollection[i + 1].dataSource, newResCollection[i + 1].groupId, newResCollection[i].dataSource[j][newResCollection[i].id]) : this._tempResource.length - 1;
                            (ej.isNullOrUndefined(valuefirst) && ej.isNullOrUndefined(valuelast)) ? newResCollection[i].dataSource[j] = 0 : "";
                            if (!ej.isNullOrUndefined(valuefirst) && !ej.isNullOrUndefined(valuelast) && newResCollection[i].dataSource[j] !== 0) {
                                res.push(newResCollection[i].dataSource[j]);
                                this.resourceValue = res.length;
                                if (i <= this._tempResource.length - 2) {
                                    query = new ej.Query().where(newResCollection[i + 1].groupId, ej.FilterOperators.equal, newResCollection[i].dataSource[j][newResCollection[i].id]);
                                    var resApp = new ej.DataManager(newResCollection[i + 1].dataSource).executeLocal(query);
                                    if (i <= this._tempResource.length - 3) {
                                        for (k = 0; k < resApp.length; k++)
                                            resAppValueCount = resAppValueCount + (!ej.isNullOrUndefined(resApp[k].count) ? resApp[k].count : 0);

                                        resourceLength = this.model.orientation == "vertical" ? resAppValueCount : resAppValueCount + resApp.length;
                                        newResCollection[i].dataSource[j].count = resourceLength;
                                        resAppValueCount = 0;
                                    }
                                    if (i == this._tempResource.length - 2) {
                                        newResCollection[i].dataSource[j].count = resApp.length;
                                        resourceLength = resApp.length;
                                    }
                                    this.resourceValue = resourceLength;
                                    resApp.length = 0;
                                }
                                if (this._resWorkWeek) {
                                    var weekCount = 0;
                                    if (i != this._tempResource.length - 1) {
                                        var query = new ej.Query().where(resClone[i + 1].groupId, ej.FilterOperators.equal, resClone[i].dataSource[j][resClone[i].id]);
                                        var colCount = new ej.DataManager(resClone[i + 1].dataSource).executeLocal(query);
                                        for (var a = 0; a < colCount.length; a++) {
                                            weekCount += !ej.isNullOrUndefined(colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : !ej.isNullOrUndefined(colCount[a].colspan) ? colCount[a].colspan : viewColCount;
                                        }
                                    }
                                    else {
                                        weekCount += !ej.isNullOrUndefined(resClone[i].dataSource[j][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? resClone[i].dataSource[j][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : viewColCount;
                                    }
                                    resClone[i].dataSource[j]["colspan"] = weekCount;
                                    this.resourceValue = weekCount;
                                }
                                (this.currentView() != "agenda") && resources.push({ resourceNam: newResCollection[i].dataSource[j][newResCollection[i].text], colspan: (this._resWorkWeek) ? this.resourceValue : this.resourceValue * viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(newResCollection[i].dataSource[j], { classname: (this._tempResource.length - 1 == i) ? "e-childnode" : "e-parentnode" })), userResTemplId: userResTemplId });
                                this.level_Resources.push(newResCollection[i].dataSource[j]);
                                res.length = 0;

                            }
                            if (this.model.orientation == "vertical" && this.currentView() != "agenda" && tbody !== null && cols != null) {
                                leftCellwidth = view == "month" ? 50 : 56;
                                resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
                                variable[i] = ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml)[0];
                            }
                        }
                        valueCount[i] = newResCollection[i].dataSource;
                        resources.length = 0;
                    }
                    this.render_Resources = valueCount;
                    this.model.orientation == "vertical" && this.currentView() != "agenda" ? tbody.append(variable) : "";
                }
            }
            else {
                for (var k = 0; k < this._tempResource.length; k++) {
                    this.render_Resources.push(this._tempResource[k].resourceSettings.dataSource);
                }
                this.res1 = [0];
            }
            return tbody;
        },

        _getMultipleResourceAlldayApp: function (renderDate, day, res, i) {
            this.allDayCount = [];
            if ((new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(this._processed[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (this._processed[i][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()] == this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings.id]) &&
				(this._processed[i][this._appointmentSettings["allDay"]] === true || (((new Date(this._processed[i][this._appointmentSettings["endTime"]]) - new Date(this._processed[i][this._appointmentSettings["startTime"]])) / 3600000) >= 24))) {
                this._setAllDayPos(this._processed[i], day, res);
                this._filtered.push(this._processed[i]);
                this.allDayCount.push(i);
            }
        },

        _getResourceColor: function (record) {
            var newResCollection = this._resCollection;
            var resourceDataIndex, appointData = "", appointCustomcss = "";
            if (!ej.isNullOrUndefined(this.model.group)) {
                for (var a = 0; a < this.render_Resources.length; a++) {
                    resourceDataIndex = this._findResourceIndex(this.render_Resources[a], newResCollection[a].id, record[this._appointmentSettings.resourceFields.split(',')[a].trim()]);
                    if (!ej.isNullOrUndefined(resourceDataIndex)) {
                        appointData = (appointData == "" || ej.isNullOrUndefined(appointData)) ? this.render_Resources[a][resourceDataIndex][newResCollection[a].color] : appointData;
                        appointCustomcss = (appointCustomcss == "" || ej.isNullOrUndefined(appointCustomcss)) ? this.render_Resources[a][resourceDataIndex][newResCollection[a].appointmentClass] : appointCustomcss;
                        if (!ej.isNullOrUndefined(appointData) && !ej.isNullOrUndefined(appointCustomcss)) break;
                    }
                }
                appointData = !ej.isNullOrUndefined(appointData) && appointData != "" ? appointData : "";
                appointCustomcss = !ej.isNullOrUndefined(appointCustomcss) && appointCustomcss != "" ? appointCustomcss : "";
            }
            else {
                resourceDataIndex = this._findResourceIndex(this.render_Resources[this.render_Resources.length - 1], newResCollection[newResCollection.length - 1].id, record[this._appointmentSettings.resourceFields.split(',')[this._appointmentSettings.resourceFields.split(',').length - 1].trim()]);
                if (!ej.isNullOrUndefined(resourceDataIndex)) {
                    appointData = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color] : appointData;
                    appointCustomcss = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass] : appointCustomcss;
                }
            }
            return { appointData: appointData, appointCustomcss: appointCustomcss };
        },

        _getResourceValue: function (target, index) {
            var resDetails;
            if (ej.scheduleFeatures.resources && (this._tempResource.length != 0)) {
                var resource = this._getResourceDetails(target);
                resDetails = ej.DataManager(this._resCollection[resource.length - 1].dataSource).executeLocal(new ej.Query().where(this._tempResource[resource.length - 1].resourceSettings["id"], "equal", resource[0].id))[0];
            }
            return resDetails;
        },

        _getResourceDetails: function (target, index) {
            if ((this._tempResource.length != 0)) {
                if (this._tempResource.length > 0) {
                    var noOfDays = this.currentView() == "day" ? 1 : this.currentView() == "week" || this.currentView() == "month" ? 7 : this.model.workWeek.length;
                    noOfDays = (this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 : (this.currentView() == "customview" && this._dateRender.length < 7) ? this._dateRender.length : noOfDays;
                    index = this.currentView() === "month" || this.currentView() == "customview" ? target.index() : (!ej.isNullOrUndefined(this._cellIndex) && ej.isNullOrUndefined(this._multiple)) ? this._cellIndex : target.index();
                    !target.hasClass("e-detailedapp") ? this.index = index : "";
                    index = target.hasClass("e-detailedapp") ? this.index : index;
                    if (this._resWorkWeek) {
                        var resIndex = 0;
                        for (var a = 0; a < this._valueCollection.length; a++) {
                            if (!ej.isNullOrUndefined(this._valueCollection[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                                resIndex += this._valueCollection[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            else
                                resIndex += this.model.workWeek.length;

                            if (resIndex > target.index()) {
                                index = a;
                                break;
                            }
                        }
                    }
                    else
                        index = this.model.orientation == "vertical" ? parseInt(index / noOfDays) : !ej.isNullOrUndefined(this._workCellIndex) ? this._workCellIndex : target.parent().index();
                    var res1 = this.model.orientation == "vertical" ? this._valueCollection : this._resCollect;
                    var group, resourceData, query, result; this._resourceCollection = [];
                    var newResCollection = this._resCollection;
                    for (var i = newResCollection.length - 1; i >= 0; i--) {
                        if (i == newResCollection.length - 1) {
                            if (!ej.isNullOrUndefined(this.model.group)) {
                                this._resourceCollection.push({ id: res1[index][newResCollection[i].id] });
                                group = res1[index][newResCollection[i].groupId];
                            }
                            else {
                                this._resourceCollection.push({ id: newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].id] });
                                group = newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].groupId];
                            }
                        }
                        else {
                            resourceData = newResCollection[i].dataSource instanceof ej.DataManager ? newResCollection[i].dataSource : ej.DataManager(newResCollection[i].dataSource);
                            query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, group);
                            result = resourceData.executeLocal(query);
                            this._resourceCollection.push({ id: result[0][newResCollection[i].id] });
                            group = result[0][newResCollection[i].groupId];
                        }
                    }
                    return this._resourceCollection;
                }
            }
        },

        _getResourceFields: function (obj) {
            if (!ej.isNullOrUndefined(this.model.group) || this._tempResource.length > 1) {
                for (var j = 0, i = this._resourceCollection.length - 1; j < this._resourceCollection.length; j++, i--)
                    obj[this._appointmentSettings.resourceFields.split(',')[j].trim()] = this._resourceCollection[i].id;
            }
            else
                obj[this._appointmentSettings.resourceFields.split(',')[0].trim()] = this._resourceCollection[0].id;
            return obj;
        },
        _getDragDropResourceData: function (proxy, cellIndex, newAddList) {
            if (!ej.isNullOrUndefined(cellIndex)) {
                var noOfCols = proxy.currentView() == "day" ? 1 : proxy.currentView() == "week" || proxy.currentView() == "month" ? 7 : proxy.model.workWeek.length;
                noOfCols = (proxy.currentView() == "customview" && proxy._dateRender.length >= 7) ? 7 : (proxy.currentView() == "customview" && proxy._dateRender.length < 7) ? proxy._dateRender.length : noOfCols;
                var index = proxy.model.enableRTL ? proxy.res1.length - Math.floor(cellIndex / noOfCols) - 1 : Math.floor(cellIndex / noOfCols);
                if (proxy._resWorkWeek) {
                    var resIndex = 0;
                    for (var a = 0; a < proxy.res1.length; a++) {
                        if (!ej.isNullOrUndefined(proxy.res1[a][proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["workWeek"]]))
                            resIndex += proxy.res1[a][proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["workWeek"]].length;
                        else
                            resIndex += proxy.model.workWeek.length;

                        if (resIndex > cellIndex) {
                            index = a;
                            break;
                        }
                    }
                }
                var newRes = proxy.model.orientation == "vertical" ? proxy.res1[index] : proxy._resCollect[cellIndex];
                newAddList[proxy._appointmentSettings.resourceFields.split(',')[proxy._appointmentSettings.resourceFields.split(',').length - 1].trim()] = newRes[proxy.model.resources[proxy.model.resources.length - 1].resourceSettings.id];
                if (proxy._appointmentSettings.resourceFields.split(',').length > 1)
                    newAddList[proxy._appointmentSettings.resourceFields.split(',')[proxy._appointmentSettings.resourceFields.split(',').length - 2].trim()] = newRes[proxy.model.resources[proxy.model.resources.length - 1].resourceSettings.groupId];
            }
            return newAddList;
        },

        _renderResourceData: function (targetElement, index) {
            if ((targetElement.hasClass("e-workcells") || targetElement.hasClass("e-alldaycells") || targetElement.hasClass("e-monthcells")) && !targetElement.hasClass("e-resourceheadercells")) this._getResourceDetails(targetElement)
            var fieldCollection = [], collection = [];
            if (this._tempResource.length) {
                for (var k = this._resourceCollection.length - 1; k >= 0; k--) {
                    var resourceDataIndex = this._findResourceIndex(this._resCollection[k].dataSource, this._resCollection[k].id, this._resourceCollection[(this._resourceCollection.length - 1) - k].id);
                    fieldCollection.push(this._resCollection[k].dataSource[resourceDataIndex]);
                    if (k != 0) {
                        var query = new ej.Query().where(ej.Predicate(this._resCollection[k].groupId, ej.FilterOperators.equal, this._resCollection[k].dataSource[resourceDataIndex][this._resCollection[k].groupId]));
                        var resApp = new ej.DataManager(this._resCollection[k].dataSource).executeLocal(query);
                        index = this._findResourceIndex(resApp, this._resCollection[k].id, this._resourceCollection[(this._resourceCollection.length - 1) - k].id);
                        collection = resApp;
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("clearText");
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("option", "dataSource", collection);
                        this._appointmentAddWindow.find('.owner_' + (k)).data("ejAutocomplete").selectValueByKey(collection[index][this._resCollection[k].id]);
                    }
                    else {
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("clearText");
                        this._appointmentAddWindow.find('.owner_' + (k)).data("ejAutocomplete").selectValueByKey(fieldCollection[(this._resourceCollection.length - 1) - k][this._resCollection[k].id]);
                    }
                }
            }
        },

        _bindResourcesData: function () {
            if ((this._tempResource.length != 0)) {
                this._resourceInfo = []; var resFlag = false;
                for (var i = 0; i < this._tempResource.length; i++) {
                    if (!ej.isNullOrUndefined(this._tempResource[i].resourceSettings)) {
                        if (ej.isNullOrUndefined(this._tempResource[i].resourceSettings.query) || !(this._tempResource[i].resourceSettings.query instanceof ej.Query))
                            this._tempResource[i].resourceSettings.query = ej.Query();
                        if (this._tempResource[i].resourceSettings.dataSource instanceof ej.DataManager)
                            this._initResourceData(this._tempResource[i].resourceSettings, i);
                        else {
                            this._resourceInfo.push(this._tempResource[i].resourceSettings);
                            resFlag = true;
                        }
                    }
                }
                if (resFlag)
                    this._renderInitSchedule();
            }
        },

        _renderResourceElements: function ($appWindow) {
            for (var i = 0; i < this._tempResource.length; i++) {
                $appWindow += "<tr><td class='e-leftfields e-textlabel'>" + this._tempResource[i].title + ":</td><td colspan='3' class='e-rightfields'><input id='" + this._id + "_ownerfield_" + i + "'  class='owner_" + i + "' type='text' value=''/><div id='ownerlist'></div></td></tr>";
            }
            return $appWindow;
        },

        _renderResourcesTemplate: function () {
            if (this.model.orientation == "vertical")
                this.resourceHeadTemplate = $.templates(resourceHeadTemplate());
        }
    };
})(jQuery, Syncfusion);